Subject: Re: [RFC] Alternate WE-21 support (core API)

From: Larry Finger <[email-masked]>
Date: Wed, 06 Sep 2006 16:43:54 -0500

John W. Linville wrote:
> On Thu, Aug 31, 2006 at 04:00:05PM +0200, Johannes Berg wrote:
>> On Thu, 2006-08-31 at 06:51 -0700, Jouni Malinen wrote:
>>
>>> I don't know about the others, but long/short retry limits have users
>>> (e.g., Host AP driver) and these drivers are currently forced to use a
>>> hack to do this without this cleanup. Furthermore, this part does not
>>> add a new ioctl.
>> It does, however, add new parameters and things that'd need to be
>> translated in the compat layer later. Hence, even there, I'd prefer to
>> add them directly into nl80211. However, the compat code for that
>> shouldn't be that bad, so I can see that as a softer target :) But I
>> don't want to see new ioctls for sure.
> 
> OK, I think we all agree that there are good parts to Jean's WE-21
> patch.  Below I've made an attempt to separate the wheat from the chaff
> (or to cut the baby in half)...
> 
> Is this patch acceptable to the group?  Does it make things better?
> Or worse?  Did I leave-out anything that should still go in?  Did I
> take too much?
> 
> Let me know what you think...?

> + *
> + * The issue : wireless_send_event() is often called in interrupt context,
> + * while the Netlink layer can never be called in interrupt context.
> + * The fully formed RtNetlink events are queued, and then a tasklet is run
> + * to feed those to Netlink.
> + * The skb_queue is interrupt safe, and its lock is not held while calling
> + * Netlink, so there is no possibility of dealock.
                                              ^^^^^^^
You might as well fix the typo now. Otherwise, it looks OK to me. I've been running the original 
patch for several days with no problems. I don't think you removed anything essential.

Larry